# Overview 

This section shows how this package can be used for some applications, giving an example of how to use this package beyond the simple examples in the tutorials. The applications we consider are:

- [Interpolation](interpolation.md): How to use Delaunay triangulations for interpolation. We consider spatial interpolation, showing an example of what has been implemented in [NaturalNeighbours.jl](https://github.com/DanielVandH/NaturalNeighbours.jl) using this package.
- [Cellular Biology](cell_simulations.md): How to use Delaunay triangulations to simulate some cell dynamics.
- [Solving PDEs](pde_discretisation.md): How to use Delaunay triangulations to define a mesh for a PDE in two dimensions. This follows what has been implemented in [FiniteVolumeMethod.jl](https://github.com/SciML/FiniteVolumeMethod.jl).

More applications could be added in the future - feel free to contribute some if you believe they are interesting.